/* Utility Functions */

//DOM Document Wrapper technique - see http://www.webreference.com/programming/javascript/domwrapper/index.html
if (document.implementation && document.implementation.createDocument)
{
  Document.prototype.loadXML = function(strXML) {
  
  var objDOMParser = new DOMParser();
	var objDoc = objDOMParser.parseFromString(strXML, "text/xml");

	while (this.hasChildNodes())
    this.removeChild(this.lastChild);

		for (var i=0; i < objDoc.childNodes.length; i++) 
		{
		  var objImportedNode = this.importNode(objDoc.childNodes[i], true);
		  this.appendChild(objImportedNode);
		}
	}

	Document.prototype.xml = "";
	Node.prototype.__defineGetter__("xml", _Node_getXML);
}

function _Node_getXML() 
{
	var objXMLSerializer = new XMLSerializer;
	var strXML = objXMLSerializer.serializeToString(this);
	return strXML;
}

function formatURL(url)
{
  return encodeURI(url.replace(/#\d*/,""));
}

function getTextSelection() 
{
    var popupNode = document.popupNode;
    var sText = "";

    if ((popupNode instanceof HTMLTextAreaElement) || (popupNode instanceof HTMLInputElement && popupNode.type == "text")) {
        sText = popupNode.value.substring(popupNode.selectionStart, popupNode.selectionEnd);
    } 
    else {
        var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
        sText = focusedWindow.getSelection().toString();
    }

    sText = sText.replace(/(\n|\r|\t)+/g, " ").replace(/(^\s+)|(\s+$)/g, "");
    return sText;
}